﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CG1.Core.Mathematics;
using CG1.Core.Geometry;

namespace CG1.Ex3
{
    public partial class Form1 : Form
    {
        #region Properties
        #region Matrix Prop
        double angle = 0;
        Vector4 K = new Vector4();
        Vector4 L = new Vector4();
        //scale/translate vector
        Vector4 ST = new Vector4();
        Matrix44 A = new Matrix44();
        //result and also matrix for rotation, scale, translate
        Matrix44 B = new Matrix44();
        #endregion

        #region Drawing Prop

        //To Do

        #endregion

        #endregion

        #region Construction

        public Form1()
        {
            InitializeComponent();
            gST.Enabled = false;
            gAngle.Enabled = false;
        }

        #endregion

        #region Operation Matrix

        #region Functions

        double Parse(String text)
        {
            double res = 0;
            Double.TryParse(text, out res);
            return res;
        }

        void ReadValues()
        {
            A.M[0, 0] = Parse(tbA00.Text);
            A.M[0, 1] = Parse(tbA01.Text);
            A.M[0, 2] = Parse(tbA02.Text);
            A.M[0, 3] = Parse(tbA03.Text);
            A.M[1, 0] = Parse(tbA10.Text);
            A.M[1, 1] = Parse(tbA11.Text);
            A.M[1, 2] = Parse(tbA12.Text);
            A.M[1, 3] = Parse(tbA13.Text);
            A.M[2, 0] = Parse(tbA20.Text);
            A.M[2, 1] = Parse(tbA21.Text);
            A.M[2, 2] = Parse(tbA22.Text);
            A.M[2, 3] = Parse(tbA23.Text);
            A.M[3, 0] = Parse(tbA30.Text);
            A.M[3, 1] = Parse(tbA31.Text);
            A.M[3, 2] = Parse(tbA32.Text);
            A.M[3, 3] = Parse(tbA33.Text);

            K.X = Parse(tbKX.Text);
            K.Y = Parse(tbKY.Text);
            K.Z = Parse(tbKZ.Text);
            K.W = Parse(tbKW.Text);
        }

        void WriteValues()
        {
            tbB00.Text = B.M[0, 0].ToString("F2");
            tbB01.Text = B.M[0, 1].ToString("F2");
            tbB02.Text = B.M[0, 2].ToString("F2");
            tbB03.Text = B.M[0, 3].ToString("F2");
            tbB10.Text = B.M[1, 0].ToString("F2");
            tbB11.Text = B.M[1, 1].ToString("F2");
            tbB12.Text = B.M[1, 2].ToString("F2");
            tbB13.Text = B.M[1, 3].ToString("F2");
            tbB20.Text = B.M[2, 0].ToString("F2");
            tbB21.Text = B.M[2, 1].ToString("F2");
            tbB22.Text = B.M[2, 2].ToString("F2");
            tbB23.Text = B.M[2, 3].ToString("F2");
            tbB30.Text = B.M[3, 0].ToString("F2");
            tbB31.Text = B.M[3, 1].ToString("F2");
            tbB32.Text = B.M[3, 2].ToString("F2");
            tbB33.Text = B.M[3, 3].ToString("F2");

            tbLX.Text = L.X.ToString("F2");
            tbLY.Text = L.Y.ToString("F2");
            tbLZ.Text = L.Z.ToString("F2");
            tbLW.Text = L.W.ToString("F2");
        }

        #endregion

        #region GUI

        private void bCalc_Click(object sender, EventArgs e)
        {
            ReadValues();

            switch (cbOp.SelectedItem as String)
            {
                //To Do
            }

            WriteValues();
        }

        private void cbOp_SelectedIndexChanged(object sender, EventArgs e)
        {
            gST.Enabled = false;
            gAngle.Enabled = false;
            switch (cbOp.SelectedItem as String)
            {
                case "L = Translate(K)":
                    gST.Enabled = true;
                    break;
                case "L = Scale(K)":
                    gST.Enabled = true;
                    break;
                case "L = RotateX(K)":
                    gAngle.Enabled = true;
                    break;
                case "L = RotateY(K)":
                    gAngle.Enabled = true;
                    break;
                case "L = RotateZ(K)":
                    gAngle.Enabled = true;
                    break;
                case "L = RotateXYZ(K)":
                    gAngle.Enabled = true;
                    break;
            }
        }

        private void tbSTX_TextChanged(object sender, EventArgs e)
        {
            ST.X = Parse(tbSTX.Text);
        }

        private void tbSTY_TextChanged(object sender, EventArgs e)
        {
            ST.Y = Parse(tbSTY.Text);
        }

        private void tbSTZ_TextChanged(object sender, EventArgs e)
        {
            ST.Z = Parse(tbSTZ.Text);
        }

        private void tbAngle_TextChanged(object sender, EventArgs e)
        {
            angle = Parse(tbAngle.Text);
        }

        #endregion

        #endregion

        #region Drawing

        #region Functions

        void CreatePolyline()
        {
            //To Do
        }

        private void Draw()
        {
            //To Do
        }

        #endregion

        #region GUI
        private void button1_Click(object sender, EventArgs e)
        {
            //clear all
            //To Do
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            //To Do

        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            //To Do
        }

        #endregion

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            //loose the pen
            //To Do
        }

        #endregion

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            //draw points
            //To Do
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            rPoly.Checked = true;
        }
    }
}
